#ifndef HEADERS_H_
#define HEADERS_H_

//Cargamos librerías
#include <iostream>
#include <stdlib.h>
#include <fstream>
#include "time.h"

using namespace std;
//Declaramos como constante el número de récords que habrán en los ránkings
const int kNUMRANKING = 10;

//Declaramos la estructura del ranking del minijuego 1 (20 Operaciones)
typedef struct{
	int tiempo;
	string nick;
}TRankingRecord1;

//Y el array de estructuras
typedef TRankingRecord1 TRanking1[kNUMRANKING];

//Declaramos la estructura del ranking que se usará en el minijuego 2 y 3
typedef struct{
	string nick;
	float eficacia;
	int tiempo;
	int numoperaciones;
	int puntuacion;
}TRankingRecord2;

typedef TRankingRecord2 TRanking2[kNUMRANKING];


//Declaramos todos los módulos

//Módulo para pausar el programa según los segundos que se le pasen
void wait (int segundos);
//Módulo para mostrar la pantalla de inicio
void screenInicial(char estiloMenu);
//Módulo para mostrar la pantalla del menú (siendo diferente según desbloqueemos cosas)
int mostrarMenu(char estiloMenu,bool unlock1,bool unlock2);
//Módulo del primer minijuego
int veinteOperaciones(TRanking1 &ranking);
//Módulo del segundo minijuego
float operacionesContrarreloj(TRanking2 &ranking2);
//Módulo del tercer minijuego
float maratonOperaciones(TRanking2 &ranking3);
//Módulo encargado de mostrar todos los récords de un raking, según la variable tipo que se le pase
void mostrarRanking(TRanking1 ranking,TRanking2 ranking2,TRanking2 ranking3,int tipo, char estiloMenu);
//The cake is a lie
void trollface ();
//Módulo encargado de mostrar el menú de selección de Rankings y redireccionar a mostrarRanking en cada caso
void menuRanking(TRanking1 ranking, TRanking2 ranking2, TRanking2 ranking3, bool unlock1, bool unlock2,char estiloMenu);
//Módulos encargados de introducir los récords en las estructuras de los rankings
void gestionarRanking1(int tiempo,TRanking1 &ranking);
void gestionarRanking2(int tiempo, float eficacia, int operaciones,int puntuacion,TRanking2 &ranking2);
void gestionarRanking3(int tiempo, float eficacia, int operaciones,int puntuacion,TRanking2 &ranking3);
//Módulos encargados del guardado y la carga de los récords y avances del juego
void guardarDatos(TRanking1 ranking, TRanking2 ranking2, TRanking2 ranking3, bool unlock1, bool unlock2, bool unlock3);
void cargarDatos(TRanking1 &ranking, TRanking2 &ranking2, TRanking2 &ranking3, bool &unlock1, bool &unlock2, bool &unlock3);


#endif /* HEADERS_H_ */
